about summary refs log tree commit diff
path: root/third_party/git/GIT-VERSION-GEN
diff options
context:
space:
mode:
Diffstat (limited to 'third_party/git/GIT-VERSION-GEN')
-rwxr-xr-xthird_party/git/GIT-VERSION-GEN40
1 files changed, 40 insertions, 0 deletions
diff --git a/third_party/git/GIT-VERSION-GEN b/third_party/git/GIT-VERSION-GEN
new file mode 100755
index 0000000000..a1539a7ce6
--- /dev/null
+++ b/third_party/git/GIT-VERSION-GEN
@@ -0,0 +1,40 @@
+#!/bin/sh
+
+GVF=GIT-VERSION-FILE
+DEF_VER=v2.23.0
+
+LF='
+'
+
+# First see if there is a version file (included in release tarballs),
+# then try git-describe, then default.
+if test -f version
+then
+	VN=$(cat version) || VN="$DEF_VER"
+elif test -d ${GIT_DIR:-.git} -o -f .git &&
+	VN=$(git describe --match "v[0-9]*" HEAD 2>/dev/null) &&
+	case "$VN" in
+	*$LF*) (exit 1) ;;
+	v[0-9]*)
+		git update-index -q --refresh
+		test -z "$(git diff-index --name-only HEAD --)" ||
+		VN="$VN-dirty" ;;
+	esac
+then
+	VN=$(echo "$VN" | sed -e 's/-/./g');
+else
+	VN="$DEF_VER"
+fi
+
+VN=$(expr "$VN" : v*'\(.*\)')
+
+if test -r $GVF
+then
+	VC=$(sed -e 's/^GIT_VERSION = //' <$GVF)
+else
+	VC=unset
+fi
+test "$VN" = "$VC" || {
+	echo >&2 "GIT_VERSION = $VN"
+	echo "GIT_VERSION = $VN" >$GVF
+}